local mod = RW:Boss("The Assembly of Iron", "Ulduar", "Ulduar")
local L

---------------------------
-- Variables
local tOverloadCD, tOverloadCast, wOverload
local tLightningWhirlDur, wLightningWhirl
local tOverPDur
local tPunchCast
local tRPowerCD, tRPowerCast
local tRDeathCD
local tRSummoningCast, tRSummoningDur, wRSummoning
local wShield
local tLightTDur
local tBerserk



---------------------------
-- Init

function mod:OnRegister()
	L = mod:RegisterLocale(self:GetName(), "enUS", true)
	if L then
		L.name = "The Assembly of Iron"
		
		L.YellPull = "You will not defeat the Assembly of Iron so easily, invaders!"
		L.Shield_msg = "Runemaster Molgeim damage buffed!"
		L.Shield_opt = "Shield of Runes broken buff warning"
	end

	L = mod:GetLocale()
	self.L = L
	
	self:SetTrigger(L.YellPull, 32867, 32927, 32857)
	self:SetWin(32867, 32927, 32857)
	
	self:AddToCategory("Stormcaller Brundir", "Runemaster Molgeim", "Steelbreaker")
	self:AddToCategory("Stormcaller Brundir", 63481, 61887, 63483)
	self:AddToCategory("Runemaster Molgeim", 61973, 63490, 62273, L.Shield_opt)
	--self:AddGeneralOption(L.Shield_opt, "Runemaster Molgeim", select(3, GetSpellInfo(62277)))
	self:AddToCategory("Steelbreaker", 61888, 61903)

	tOverloadCD, tOverloadCast = self:CDTimer(45, 63481), self:CastTimer(6, 63481)
	tLightningWhirlDur = self:DurTimer(5, 63483)
	wLightningWhirl = self:CastWarning(63483)
	tOverPDur = self:DurTargetTimer(30, 61888)
	tPunchCast = self:CastTimer(3, 61903)
	tRPowerCD, tRPowerCast = self:CDTimer(30, 61973), self:CastTimer(1.5, 61973)
	tRDeathCD = self:CDTimer(30, 63490)
	tRSummoningCast = self:CastTimer(62273)
	tRSummoningDur = self:DurTimer(10, 62273)
	wOverload = self:RunawayWarning(63481)
	wRSummoning = self:CastWarning(62273)
	wShield = self:CustomWarning(L.Shield_msg, L.Shield_opt, 62277, L.Shield_opt)
	tLightTDur = self:DurTimer(25, 61887)

	tBerserk = self:BerserkTimer(900)
end

---------------------------
-- Locals

---------------------------
-- Start

function mod:OnEngage(trigger)
	self:Track("Overload", 61869, 63481, 61878)
	self:Track("LightningWhirl", 63483, 61915)
	self:Track("OverwhelmingPower", 64637, 61888)
	self:Track("FusionPunch", 61903, 63493)
	self:Track("RuneofPower", 61973, 61974)
	self:Track("RuneofDeath", 62269, 63490)
	self:Track("RuneofSummoning", 62273)
	self:Track("ShieldofRunes", 62277, 63967)
	self:Track("LightningTendrils", 61887, 63486)

	tBerserk:Start()

end

function mod:Overload(event, args)
	if event == "SPELL_CAST_SUCCESS" then
	 	tOverloadCast:Start()
		tOverloadCD:Schedule(6)
		wOverload:Show()
	end
end

function mod:LightningWhirl(event, args)
	if event == "SPELL_CAST_SUCCESS" then
		tLightningWhirlDur:Start()
		wLightningWhirl:Show()
	end
end

function mod:OverwhelmingPower(event, args)
	if event == "SPELL_AURA_APPLIED" then
		if GetInstanceDifficulty() == 1 then
			tOverPDur:Start(60, args.dName)
		else
			tOverPDur:Start(30, args.dName)
		end
	end
end

function mod:FusionPunch(event, args)
	if event == "SPELL_CAST_START" then
		tPunchCast:Start()
	end
end

function mod:RuneofPower(event, args)
	if event == "SPELL_CAST_START" then
		tRPowerCast:Start()
		tRPowerCD:Schedule(1.5)
	end
end

function mod:RuneofDeath(event, args)
	if event == "SPELL_CAST_SUCCESS" then
		tRDeathCD:Start()
	end
end

function mod:RuneofSummoning(event, args)
	if event == "SPELL_CAST_START" then
		tRSummoningCast:Start()
		tRSummoningDur:Schedule(2)
		wRSummoning:Show()
	end
end

function mod:ShieldofRunes(event, args)
	if event == "SPELL_AURA_APPLIED" then
		wShield:Show()
	end
end

function mod:LightningTendrils(event, args)
	if event == "SPELL_CAST_SUCCESS" then
		tLightTDur:Start()
	end
end
